//+------------------------------------------------------------------+ 
//|    _TRO_BuyersSellers                                            | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpldone.com/" 
//+------------------------------------------------------------------+
// used some code from:
//+------------------------------------------------------------------+
//|                                     Waddah Attar Buy Sell Volume |
//|                               Copyright  2007, ww.metaforex.net |
//|                                   Waddah Attar www.metaforex.net |
//+------------------------------------------------------------------+
//#property copyright "Copyright  2007, www.metaforex.net"
//#property link      "www.metaforex.net"
//----
#property indicator_chart_window
#property indicator_buffers 0

  extern string note1 = "Display the info in what corner?";
  extern string note2 = "Upper left=0; Upper right=1";
  extern string note3 = "Lower left=2; Lower right=3";
  extern int    WhatCorner=0;

  extern string myFont     = "Simplified Arabic Fixed" ;
  extern int    myFontSize = 20 ;
  extern color  myBuyerColor  = Lime ;  
  extern color  mySellerColor = Red ;  
   
//---- buffers
double P1;
double P2;

double P1Buffer[];
double P2Buffer[];
double P3Buffer[];

//----
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   IndicatorDigits(0);
   
   Comment("_TRO_BuyersSellers");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete("DBuyers");
   ObjectDelete("DSellers");
  
   Comment("");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

   int i,ii;
   static int pii=-1;
   
   for(i = 0; i <iBars(Symbol(),PERIOD_M1) ; i++)
     {
       ii = iBarShift(Symbol(), Period(), iTime(Symbol(),PERIOD_M1,i), true);
       //----
       if (pii!=ii)
       {
         P1=0;
         P2=0;
         P1Buffer[ii]=0;
         P2Buffer[ii]=0;
         P3Buffer[ii]=0;
       }
       
       if (ii != -1)
       {
         if (iClose(Symbol(),PERIOD_M1,i)>iClose(Symbol(),PERIOD_M1,i+1))
         {
           P1 = P1+(iVolume(Symbol(),PERIOD_M1,i));
         }
         if (iClose(Symbol(),PERIOD_M1,i)<iClose(Symbol(),PERIOD_M1,i+1))
         {
           P2 = P2+(iVolume(Symbol(),PERIOD_M1,i));
         }
         if (iClose(Symbol(),PERIOD_M1,i)==iClose(Symbol(),PERIOD_M1,i+1))
         {
           P1 = P1+(iVolume(Symbol(),PERIOD_M1,i)/2);
           P2 = P2+(iVolume(Symbol(),PERIOD_M1,i)/2);
         }
       }
       P1Buffer[ii]=P1;
       P2Buffer[ii]=P2;
       P3Buffer[ii]=P1-P2;

       pii=ii;
    }
    
    SetLabel("_Buyers", "Buyers=" +DoubleToStr(P1,0),1,30,myFont, myFontSize,0, myBuyerColor);
    SetLabel("_Sellers","Sellers="+DoubleToStr(P2,0),1,92,myFont, myFontSize,0, mySellerColor );
     
  
    
//----
   return(0);
  }
 
void SetLabel(string name,string txt,int x,int y,string font,int size,int angle,color clr)
  {
   int idx=0;
   if(ObjectFind(name) == -1)
     {
       ObjectCreate(name, OBJ_LABEL, idx, 0, 0);
       ObjectSetText(name, txt, size, font, clr);
       ObjectSet(name, OBJPROP_XDISTANCE, x);
       ObjectSet(name, OBJPROP_YDISTANCE, y);
       ObjectSet(name, OBJPROP_CORNER, WhatCorner);
       ObjectSet(name, OBJPROP_ANGLE, angle);
     }
   else
     {
       ObjectSet(name, OBJPROP_XDISTANCE, x);
       ObjectSet(name, OBJPROP_YDISTANCE, y);
       ObjectSetText(name, txt, size, font, clr);
       ObjectSet(name, OBJPROP_CORNER, WhatCorner);
       ObjectSet(name, OBJPROP_ANGLE, angle);
     } 
  }
  
//+------------------------------------------------------------------+