//+------------------------------------------------------------------+ 
//| TRO_D20P  http://daily20pip.com/forum/viewtopic.php?t=886        | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 



#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
#property indicator_chart_window 
#property  indicator_buffers 7 
#property  indicator_color1  Gold 
#property  indicator_color2  Blue 
#property  indicator_color3  Red 
#property  indicator_color4  Green 
#property  indicator_color5  Green 

extern bool   Sound.Alert    = true ;
extern string Sound.File     = "cashregister.wav" ; // TRO

extern bool   Show.PriceBox  = true ;
extern bool   Show.Lines     = true ;

extern int    myBoxWidth     = 2;
extern bool   show.comment   = true ;

extern double myEntryTrigger   = 21 ;
extern double myProfitTarget   = 41 ;
extern double myStopLoss       = 10 ;

extern color colorPivot         = Gold ;
extern color colorTarget       = Green ;
extern color colorBuy          = Blue ;
extern color colorShort        = Red ;

double PivotLine[]; 
double BuyLine1[]; 
double BuyLine2[]; 
double SellLine1[]; 
double SellLine2[]; 
double TargetLine1[]; 
double TargetLine2[]; 

//+------------------------------------------------------------------+ 
string symbol, tChartPeriod,  tShortName ;  
int    digits2, digits, period, win ; 
double point;

datetime Trigger ;

 
double   O, H, L, C, PP ;


//+------------------------------------------------------------------+ 
int init() 
  { 

   period       =  Period() ;   
   tChartPeriod =  TimeFrameToString(period) ;  
   digits       =  Digits ;
   point        =  Point ; 
   symbol       =  Symbol() ; 
   tShortName = symbol + tChartPeriod  ; 
    
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
 
//---- indicators 

if(Show.Lines)
{
   SetIndexStyle(0,DRAW_LINE,STYLE_DOT); 
   SetIndexStyle(1,DRAW_LINE,STYLE_DASH); 
   SetIndexStyle(2,DRAW_LINE,STYLE_DASH); 
   SetIndexStyle(3,DRAW_LINE,STYLE_DOT); 
   SetIndexStyle(4,DRAW_LINE,STYLE_DOT);  
}
else
{
   SetIndexStyle(0,DRAW_NONE); 
   SetIndexStyle(1,DRAW_NONE); 
   SetIndexStyle(2,DRAW_NONE); 
   SetIndexStyle(3,DRAW_NONE); 
   SetIndexStyle(4,DRAW_NONE);  
}


   SetIndexBuffer(0,PivotLine); 
   SetIndexBuffer(1,BuyLine1);     
   SetIndexBuffer(2,SellLine1); 
   SetIndexBuffer(3,TargetLine1);    
   SetIndexBuffer(4,TargetLine2); 
   
          
//---- 
   return(0); 
  } 
  
//+------------------------------------------------------------------+ 

int deinit() 
  { 
   ObjectDelete(tShortName+"01"); 
   ObjectDelete(tShortName+"02"); 
   ObjectDelete(tShortName+"03"); 
   ObjectDelete(tShortName+"04");    
   ObjectDelete(tShortName+"05");    
   return(0); 
  } 
  
  
//+------------------------------------------------------------------+ 
int start() 
  { 
   int    counted_bars=IndicatorCounted(); 
   int limit; 

   if(counted_bars>0) counted_bars--; 
    
   limit=Bars-counted_bars; 
    
   for (int i=limit;i>=0; i--) 
   { 
    int BarShift   = iBarShift(NULL,PERIOD_D1,Time[i],true); 
    O              = iOpen(NULL,PERIOD_D1,BarShift+1); 
    H              = iHigh(NULL,PERIOD_D1,BarShift+1);  
    L              = iLow(NULL,PERIOD_D1,BarShift+1); 
    C              = iClose(NULL,PERIOD_D1,BarShift+1);    
     
    PP             = ( H + L + C) * 0.33333 ;   
    PP             = NormalizeDouble(PP,Digits) ;
     
 
    
    PivotLine[i]   = PP ; 
    BuyLine1[i]    = PP+myEntryTrigger*point; 

    SellLine1[i]   = PP-myEntryTrigger*point; 

    TargetLine1[i] = PP+myProfitTarget*point; 
    TargetLine2[i] = PP-myProfitTarget*point;    
   } 

 


string tTime = TimeToStr(Time[0]) ;

   if(Show.PriceBox) { DoBox() ; }
  
   if ( Trigger != Time[0] &&  Sound.Alert ) 
   {
      if( Close[0] >= TargetLine1[0] ) { Trigger = Time[0] ;  PlaySound(Sound.File); }
      if( Close[0] <= TargetLine2[0] ) { Trigger = Time[0] ;  PlaySound(Sound.File); }        
   } 



if( show.comment )
{
Comment( "D20P..... ", tTime, "\n", 

         "LgTarget.... ", DoubleToStr(TargetLine1[0],digits) , "\n",  
         "LgTrigger... ", DoubleToStr(BuyLine1[0],digits) ,"\n", 
         "PivotLine.... ", DoubleToStr(PivotLine[0],digits) ,"\n",                   
         "ShTrigger... ", DoubleToStr(SellLine1[0],digits) , "\n",                  
         "ShTarget.... ", DoubleToStr(TargetLine2[0],digits) , "\n",    
     
         "O.... ", DoubleToStr(O,digits) , "\n",            
         "H.... ", DoubleToStr(H,digits) , "\n",            
         "L.... ", DoubleToStr(L,digits) , "\n",            
         "C.... ", DoubleToStr(C,digits) , "\n",                    
         "") ;
}



   return(0); 
  }  
  
//+--------- TRO MODIFICATION ---------------------------------------+  
void DoBox()    
{

       if (ObjectFind(tShortName+"01") != 0)
      {
          ObjectCreate(tShortName+"01",OBJ_ARROW,0,Time[0],TargetLine1[0]);
          ObjectSet(tShortName+"01",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"01",OBJPROP_COLOR,colorTarget);  
          ObjectSet(tShortName+"01",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"01",0,Time[0],TargetLine1[0]);
         ObjectSet(tShortName+"01",OBJPROP_COLOR,colorTarget);  
      }

       if (ObjectFind(tShortName+"02") != 0)
      {
          ObjectCreate(tShortName+"02",OBJ_ARROW,0,Time[0],BuyLine1[0]);
          ObjectSet(tShortName+"02",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"02",OBJPROP_COLOR,colorBuy);  
          ObjectSet(tShortName+"02",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"02",0,Time[0],BuyLine1[0]);
         ObjectSet(tShortName+"02",OBJPROP_COLOR,colorBuy);  
      }

 
       if (ObjectFind(tShortName+"03") != 0)
      {
          ObjectCreate(tShortName+"03",OBJ_ARROW,0,Time[0],PivotLine[0]);
          ObjectSet(tShortName+"03",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"03",OBJPROP_COLOR,colorPivot);  
          ObjectSet(tShortName+"03",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"03",0,Time[0],PivotLine[0]);
         ObjectSet(tShortName+"03",OBJPROP_COLOR,colorPivot);  
      }
 
       if (ObjectFind(tShortName+"04") != 0)
      {
          ObjectCreate(tShortName+"04",OBJ_ARROW,0,Time[0],SellLine1[0]);
          ObjectSet(tShortName+"04",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"04",OBJPROP_COLOR,colorShort);  
          ObjectSet(tShortName+"04",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"04",0,Time[0],SellLine1[0]);
         ObjectSet(tShortName+"04",OBJPROP_COLOR,colorShort);  
      }

      
       if (ObjectFind(tShortName+"05") != 0)
      {
          ObjectCreate(tShortName+"05",OBJ_ARROW,0,Time[0],TargetLine2[0]);
          ObjectSet(tShortName+"05",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"05",OBJPROP_COLOR,colorTarget);  
          ObjectSet(tShortName+"05",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"05",0,Time[0],TargetLine2[0]);
         ObjectSet(tShortName+"05",OBJPROP_COLOR,colorTarget);  
      }
                
   return(0);
}


//+--------- TRO MODIFICATION ---------------------------------------+  

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}



//+--------- TRO MODIFICATION ---------------------------------------+  

/*

Here's the simple Forex Signal
Generator and D20P calculation

BUY A = ( High+Low+Close ) /3 + 21
BUY B = ( High+Low+Close ) /3 + 41
SELL A = ( High+Low+Close ) /3 - 21
SELL B = ( High+Low+Close ) /3 - 41

READ YESTERDAY CLOSE PRICE vs PIVOT AND FOLLOW THE RULES

a. if CLOSE data between BUY A and BUY B, placed BUY on A

b. if CLOSE data above BUY B placed BUY on B

c.-if CLOSE data between BUY A and SELL A then,
-if price above the PIVOT Placed BUY on A
-if price bellow the PIVOT Placed SELL on A

d. if CLOSE data between SELL A and SELL B, placed SELL on A

e. if CLOSE data bellow SELL B placed SELL on B

ps : -Use Last Friday CLOSE data for Monday signal
-Only use BUY A/SELL A for DPG

Hope this will usefull, Idea

Please read this condition before your continue with your work http://creativecommons.org/licenses/by-nc-nd/3.0/us/
*/