//+------------------------------------------------------------------+ 
//|   TRO_HL                                                         | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 

#property indicator_chart_window

extern int    myPeriod      = 0 ;  
extern int    myShift       = 0 ;  
extern int    myPipTrigger  = 20 ;
extern int    Line_Style    = STYLE_SOLID ;
extern int    Line_Width    = 1 ;

extern int    Line_Style_Trigger    = STYLE_DOT ;
extern int    Line_Width_Trigger    = 1 ;

  
extern color  Line_Color_Hi        = Lime ;
extern color  Line_Color_HiTrigger = Green ;
extern color  Line_Color_Lo        = Red ;
extern color  Line_Color_LoTrigger = Maroon ;


string lbl[15], lbl2[15];
int n, j, i ;

string symbol, tChartPeriod, ShortName ;  

int    digits, period, win ; 

double point ;

double    HHprice, LLprice, TRIGGER, HHtrigger, LLtrigger ;
 
      
//+------------------------------------------------------------------+

int init()
{
   if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }  

   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   ShortName    =  "trohl"+symbol+period+myShift  ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
    

   ObDeleteObjectsByPrefix(ShortName);  
 
   TRIGGER = myPipTrigger * point ;
   TRO() ;
   
   return(0);
  }
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
      
//+------------------------------------------------------------------+
int deinit()
{
 
   ObDeleteObjectsByPrefix("trohl");  
   TRO() ;
return(0);
}
  
//+------------------------------------------------------------------+
int start()
{

n       = 10;
 
j       = 0 ;
 
HHprice = iHigh(symbol,period,myShift);  
LLprice = iLow(symbol,period,myShift);  

HHtrigger = HHprice - TRIGGER; 
LLtrigger = LLprice + TRIGGER;
 
j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(LLprice ,lbl[j], Line_Color_Lo , Line_Style , Line_Width ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(HHprice ,lbl[j], Line_Color_Hi , Line_Style , Line_Width  ) ;

if( myPipTrigger > 0 )
{

   HHtrigger = HHprice - TRIGGER; 
   LLtrigger = LLprice + TRIGGER;

   j       = j + 1 ;
   lbl[j]  = ShortName+j;
   drawLine(HHtrigger ,lbl[j], Line_Color_HiTrigger , Line_Style_Trigger, Line_Width_Trigger ) ;

   j       = j + 1 ;
   lbl[j]  = ShortName+j;
   drawLine(LLtrigger ,lbl[j], Line_Color_LoTrigger , Line_Style_Trigger, Line_Width_Trigger ) ;

} // if


return(0);
}
 

//+------------------------------------------------------------------+
 
void drawLine(double lvl,string name, color Col,int type, int width)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            

            ObjectSet(name, OBJPROP_STYLE, type);

            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,width);
            
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            ObjectSet(name, OBJPROP_STYLE, type);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,width);
          
         }
 
}
  

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+ 

